apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ k8s_headlamp_release }}-car-proxy-source
data:
  server.js: |
    const http = require("http");
    const https = require("https");
    const httpProxy = require("http-proxy");
    const CAR_PROXY_URL = process.env.CAR_PROXY_URL || null;
    if (!CAR_PROXY_URL) {
      console.error("CAR proxy url not defined. Set 'CAR_PROXY_URL'");
      process.exit(1);
    }
    
    const CAR_PROXY_SECURE = (process.env.CAR_PROXY_SECURE || "true").toLowerCase() === true;
    const PORT = process.env.CAR_PROXY_PORT || 8080;
    const proxy = httpProxy.createProxyServer({
      target: CAR_PROXY_URL,
      changeOrigin: true,
      secure: CAR_PROXY_SECURE,
      agent: new https.Agent({ rejectUnauthorized: false }),
    });

    console.log(`Running proxy for ${CAR_PROXY_URL} [${CAR_PROXY_SECURE && ("https" in CAR_PROXY_URL) ? "secure" : "insecure"}]`);
    const server = http.createServer((req, res) => {
      proxy.web(req, res, {}, (err) => {
        console.error("Proxy error:", err);
        res.writeHead(502);
        res.end("Bad gateway");
      });
    });

    server.listen(PORT, "0.0.0.0", () => {
      console.log(`Proxy server running on port ${PORT}`);
    });
